#pragma once
#include "common.h"
#include "AtomicWidget.h"

class ActorWidget
{
public:
    typedef AtomicWidget::DimType  DimType;
    typedef AtomicWidget::RectType RectType;

    ActorWidget(){
        m_resizeBuffer.reset(new Resizer([this](RectType rect) -> RectType {
            m_widget.Resize(rect.first, rect.second);
            return rect;
        }));
        connect(m_resizeBuffer, m_output);
    }
    ITarget<RectType>* GetInput()   { return m_resizeBuffer.get(); }
    ISource<RectType>* GetOutput()  { return &m_output;            }
private:
    typedef transformer<RectType, RectType> Resizer;
    unique_ptr<Resizer>        m_resizeBuffer;
    overwrite_buffer<RectType> m_output;
    AtomicWidget               m_widget;
};